$(() => {
const chart = $('#chart').dxPieChart({
type: 'doughnut',
palette: 'Soft Pastel',
dataSource,
title: 'The Population of Continents and Regions',
tooltip: {
enabled: false,
format: 'millions',
customizeTooltip(arg) {
return {
text: `${arg.argumentText}<br/>${arg.valueText}`,
};
},
},
size: {
height: 350,
},
onPointClick(e) {
const point = e.target;
point.showTooltip();
region.option('value', point.argument);
},
legend: {
visible: false,
},
series: [{
argumentField: 'region',
}],
}).dxPieChart('instance');
const region = $('#selectbox').dxSelectBox({
width: 250,
dataSource,
displayExpr: 'region',
valueExpr: 'region',
placeholder: 'Choose region',
onValueChanged(data) {
chart.getAllSeries()[0].getPointsByArg(data.value)[0].showTooltip();
},
}).dxSelectBox('instance');
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.1.4/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="chart"></div>
<div class="controls-pane">
<div id="selectbox"></div>
</div>
</div>
</body>
</html>
.controls-pane {
margin-top: 20px;
text-align: center;
}
.dx-selectbox {
display: inline-block;
}
const dataSource = [{
region: 'Asia',
val: 4119626293,
}, {
region: 'Africa',
val: 1012956064,
}, {
region: 'Northern America',
val: 344124520,
}, {
region: 'Latin America and the Caribbean',
val: 590946440,
}, {
region: 'Europe',
val: 727082222,
}, {
region: 'Oceania',
val: 35104756,
}];

import React from 'react';
import PieChart, { Series, Tooltip, Size, Legend } from 'devextreme-react/pie-chart';
import { SelectBox } from 'devextreme-react/select-box';
import { populationData } from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
selectedRegion: null
};
this.pieChartRef = React.createRef();
this.onPointClick = this.onPointClick.bind(this);
this.onRegionChanged = this.onRegionChanged.bind(this);
}
render() {
return (
<React.Fragment>
<PieChart
ref={this.pieChartRef}
dataSource={populationData}
onPointClick={this.onPointClick}
type="doughnut"
palette="Soft Pastel"
title="The Population of Continents and Regions"
>
<Series argumentField="region" />
<Size height={350} />
<Tooltip
enabled={false}
format="millions"
customizeTooltip={customizeTooltip}
/>
<Legend visible={false} />
</PieChart>
<div className="controls-pane">
<SelectBox
width={250}
dataSource={populationData}
displayExpr="region"
valueExpr="region"
placeholder="Choose region"
value={this.state.selectedRegion}
onValueChanged={this.onRegionChanged}
/>
</div>
</React.Fragment>
);
}
get pieChart() {
return this.pieChartRef.current.instance;
}
onPointClick({ target: point }) {
this.showTooltip(point);
}
onRegionChanged({ value }) {
const point = this.pieChart.getAllSeries()[0].getPointsByArg(value)[0];
this.showTooltip(point);
}
showTooltip(point) {
point.showTooltip();
this.setState({
selectedRegion: point.argument
});
}
}
function customizeTooltip(pointInfo) {
return {
text: `${pointInfo.argumentText}<br/>${pointInfo.valueText}`
};
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.controls-pane {
margin-top: 20px;
text-align: center;
}
.dx-selectbox {
display: inline-block;
}
export const populationData = [{
region: 'Asia',
val: 4119626293
}, {
region: 'Africa',
val: 1012956064
}, {
region: 'Northern America',
val: 344124520
}, {
region: 'Latin America and the Caribbean',
val: 590946440
}, {
region: 'Europe',
val: 727082222
}, {
region: 'Oceania',
val: 35104756
}];
System.config({
transpiler: 'plugin-babel',
meta: {
},
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16.14.0/umd/react.development.js',
'react-dom': 'npm:react-dom@16.14.0/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.7.2/prop-types.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'devextreme-react': 'npm:devextreme-react@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});

<template>
<div>
<DxPieChart
ref="pieChart"
:data-source="populationData"
type="doughnut"
palette="Soft Pastel"
title="The Population of Continents and Regions"
@point-click="onPointClick"
>
<DxSeries argument-field="region"/>
<DxSize :height="350"/>
<DxTooltip
:enabled="false"
:customize-tooltip="customizeTooltip"
format="millions"
/>
<DxLegend :visible="false"/>
</DxPieChart>
<div class="controls-pane">
<DxSelectBox
:width="250"
:data-source="populationData"
:value="selectedRegion"
display-expr="region"
value-expr="region"
placeholder="Choose region"
@value-changed="onRegionChanged"
/>
</div>
</div>
</template>
<script>
import DxPieChart, {
DxSeries,
DxTooltip,
DxSize,
DxLegend,
} from 'devextreme-vue/pie-chart';
import DxSelectBox from 'devextreme-vue/select-box';
import { populationData } from './data.js';
export default {
components: {
DxSelectBox,
DxPieChart,
DxSeries,
DxTooltip,
DxSize,
DxLegend,
},
data() {
return {
selectedRegion: null,
populationData,
};
},
methods: {
onPointClick({ target: point }) {
point.showTooltip();
this.selectedRegion = point.argument;
},
onRegionChanged({ value }) {
const pieChartInstance = this.$refs.pieChart.instance;
const point = pieChartInstance.getAllSeries()[0].getPointsByArg(value)[0];
point.showTooltip();
},
customizeTooltip(pointInfo) {
return {
text: `${pointInfo.argumentText}<br/>${pointInfo.valueText}`,
};
},
},
};
</script>
<style>
.controls-pane {
margin-top: 20px;
text-align: center;
}
.dx-selectbox {
display: inline-block;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
export const populationData = [{
region: 'Asia',
val: 4119626293,
}, {
region: 'Africa',
val: 1012956064,
}, {
region: 'Northern America',
val: 344124520,
}, {
region: 'Latin America and the Caribbean',
val: 590946440,
}, {
region: 'Europe',
val: 727082222,
}, {
region: 'Oceania',
val: 35104756,
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.2.41/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

<dx-pie-chart
id="chart"
type="doughnut"
[dataSource]="populationData"
palette="Soft Pastel"
title="The Population of Continents and Regions"
(onPointClick)="pointClick($event)"
>
<dxi-series argumentField="region"></dxi-series>
<dxo-tooltip
[enabled]="false"
format="millions"
[customizeTooltip]="customizeTooltip"
>
</dxo-tooltip>
<dxo-size [height]="350"></dxo-size>
<dxo-legend [visible]="false"></dxo-legend>
</dx-pie-chart>
<div class="controls-pane">
<dx-select-box
[width]="250"
[dataSource]="populationData"
displayExpr="region"
valueExpr="region"
placeholder="Choose region"
[value]="selectedRegion"
(onValueChanged)="valueChanged($event)"
>
</dx-select-box>
</div>
import {
NgModule, Component, ViewChild, enableProdMode,
} from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxPieChartModule, DxSelectBoxModule, DxPieChartComponent } from 'devextreme-angular';
import { Service, Population } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
})
export class AppComponent {
@ViewChild(DxPieChartComponent, { static: false }) chart: DxPieChartComponent;
populationData: Population[];
selectedRegion = '';
constructor(service: Service) {
this.populationData = service.getPopulationData();
}
pointClick(e: any) {
const point = e.target;
point.showTooltip();
this.selectedRegion = point.argument;
}
valueChanged(e: any) {
this.chart.instance.getAllSeries()[0].getPointsByArg(e.value)[0].showTooltip();
}
customizeTooltip(arg: any) {
return {
text: `${arg.argumentText}<br/>${arg.valueText}`,
};
}
}
@NgModule({
imports: [
BrowserModule,
DxPieChartModule,
DxSelectBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .controls-pane {
margin-top: 20px;
text-align: center;
}
::ng-deep .dx-selectbox {
display: inline-block;
}
import { Injectable } from '@angular/core';
export class Population {
region: string;
val: number;
}
const populationData: Population[] = [{
region: 'Asia',
val: 4119626293,
}, {
region: 'Africa',
val: 1012956064,
}, {
region: 'Northern America',
val: 344124520,
}, {
region: 'Latin America and the Caribbean',
val: 590946440,
}, {
region: 'Europe',
val: 727082222,
}, {
region: 'Oceania',
val: 35104756,
}];
@Injectable()
export class Service {
getPopulationData(): Population[] {
return populationData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.6/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.2.6/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.43',
'devextreme-angular': 'npm:devextreme-angular@22.2.6',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.2.6/*/package.json',
'npm:devextreme-angular@22.2.6/ui/*/package.json',
'npm:devextreme-angular@22.2.6/package.json',
'npm:devexpress-diagram@2.1.72/package.json',
'npm:devexpress-gantt@4.1.43/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.13.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>